////////////////////////////////////////////////////

// Programmed by WatchCat from Birch Island (mailto:f382.n5030.z2@gmail.com
// Based on BoatProp and library by Rudolf Huttary (c), Berlin 
// Comments in Russian CP866 encoding

use <naca4.scad>      // see http://www.thingiverse.com/thing:898554
use <naca_sweep.scad> // see http://www.thingiverse.com/thing:900137
use <splines.scad>
use <fillets_and_rounds.scad>


// ࠬ  
m = 2;         // ᫮ ⥩
pitch = 135;   //    
dia   = 210;   //    
ae    = 0.25;  // ᪮ ⭮襭
axis1 = 63;    //  㯨 
axis2 = 40;    //  㯨  
bore = 14.5;   //  ⢥   
shl = 72;      //  㯨
bshift = 15;   // ⣨    業 

N = 50;        // 筮 பᨬ樨


// core data to be interpolated by nSpline()
//       transform data             airfoil nacaXYZZ  
//--------------------------------------------------
A = [ //           Tz       X       Y    ZZ
        [           0,     0.04,   0.4, 0.42],
        [   0.5*dia/2,     0.04,   0.4, 0.12],
        [  0.99*dia/2,     0.04,   0.4, 0.12],
        [       dia/2,     0.04,   0.4, 0.12],
    ]; 
    // Tz - ﭨ 祭  業 
    // X  - 㪫 䨫 
    // Y  -  ᨬ㬠 㪫  थ
    // ZZ - ⮫騭  䨫

    // ᫨ 䨫 뢠 NACA4412.
    // ࢠ , 4, 뢠 㪫  業   
    // ,   0.04.
    //  , 4, 뢠  ᨬ 㪫 室
    //       । ஬ - 0.4
    // ᫥   12  뢠  ᨬ쭠 ⮫騭
    // 䨫 ⠢ 0.12    


$fn = N;         // refinement


B = nSpline(A, N);  //  interpolation

difference()  // ⠭   㯨
 {
//  add_fillets(R=2,fn=8)
  {
    union()  // ꥤ 㯨  ⥩
    {
//     add_rounds(R=1,fn=8)
     {  
      for(i=[0:360/m:359])   // 横 ନ஢ ⥩
      {
        C = gen_dat(B,N);  
        rotate([i,0,0])                 
        sweep(C, showslices=false); 
      }
     }
    rotate([0,90,0])
    cylinder(d1=axis1,d2=axis2,h=shl, center=true);    // 㯨 
    }
   } 
      rotate([0,90,0])             
      cylinder(d=bore,h=shl+axis1, center=true); // ⢥⨥  
      
      rotate([90,0,0])
      translate([shl/2-8, 0, 0])        
      cylinder(d=5.1,h=axis1, center=true);  // 诮 
 
    
 }
  
  // 㭪 ᫥ ਭ   ﭨ rad
  //   . 㫠  ன ,  
  //  㤮⢠ ᠭ
  function blade_width(rad) =
   let(bsr = (PI*dia*ae)/(1.6*m))
   let(iks = (rad+0.07*dia/2)/(1.07*dia/2))
   let(br = 2.55*bsr*iks*pow(1-iks,1/3))
     br;
  
  
  // generate all data - applies transformation and airfoil params
  function gen_dat(B,N) = 
    [for(i=[0:len(B)-1])
        
      let(R = B[i]) // ᨢ R -   㬥୮ ᨢ B
                    // ⠪ ᤥ ⮬    
                    // ᯮᮡ 饭  ⠬ 㬥୮
                    // ᨢ   ᠬ ( B[i,j])    
    
      let(r = R[0])  // ᮮ⢥㪥 r=B[i,0]
      let(L = blade_width(r)) // ᫥ ਭ  
                              // ﭨ r   
      let(X = R[1])  // X=B[i,1]
      let(Y = R[2])  // Y=B[i,2]
      let(ZZ = R[3]) // ZZ=B[i,3]
    
       // ஥ 
       Tz_(r,   // z-translate 2D-shape
        R_(0, 0,atan((2*PI*r)/pitch), //rotate 2D-shape
         T_(-(L*Y),-r*bshift/100, 0, // xyz-translate 2D-shape
           vec3D(airfoil_data(N=N,L=L,naca=[X,Y,ZZ],open=true)
       ))))
    ];


